// CO2-Sensor-Projekt   Dr. Weisser 14.12.2021     28.12.2021 
//***************************************************************************
//  File........: main.c
//  Target(s)...: ATmega32u4 mit 8MHz, 3.3V
//  Compiler....: AVR-GCC
//  Description.: CO2-Sensor-Projekt
//                mit CO2-Sensor CM1106SL-N
//                mit FRAM CY15B064J 64kbit=8k x8
//                mit RTC DS1307
//                ueber ATmega32u4
//                uebersetzt mit Makefile: make clean, make all
//                per USB geladen: make program
//***************************************************************************
/* 12.12.2021 Uebernahme Dateien aus avr_atmega32u4_7798_5717_sram_rtc 
              Make all, Make program 
              int.c fuer Abfangen versehentlicher Interrupts 
              Makefile fuer Erzeugen des Programms und Hineinladen  
              Platine mit 32u4 anstecken. LED am Spannungsregler brennt.
              LED links neben Quarz leuchtet kurz auf.
              Initialisierung Pins gemacht
              nicht noetige Treiber herausgenommen aus includes und Makefile
              WINAVR genommen mit innen WINAVR_2010
              Path gesetzt mit Regedit:
              KEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Control\
              Session Manager\Environment\Path -> 
              C:\WINAVR\bin;C:\WINAVR\utils\bin;%SystemRoot%\.... 
   13.12.2021 Rechner booten
              Eingabeaufforderung oeffnen
              cd.. cd..
              cd doc 
              cd avr_atmega32u4_co2_M1106SL-N 
              cd aktuell 
              make uebersetzt nun
              Fehlermeldung in out.c wg. lcd44780.h-Datei nicht da
              //#include "lcd44780.h" in out.c loest das Problem
              Problem weil Zeilen in Makefile per # ausgeblendet
              compiliert nun fehlerfrei
              #include "fm24c64.h" in main dazu
              fm24c64.c \ in Makefile dazu 
              compiliert fehlerfrei
              #define USB    4        in out.h um Ausgabe per USB einzuschalten 
              #include "usb_serial.h" in out.c fuer Ausgabe ueber USB 
              compiliert fehlerfrei
              Tests mit 32u4 mit 5V 16MHz
				  Aenderung COM4 auf COM5 beim Programmieren:
              avrdude -v -patmega32u4 -cavr109 -PCOM5 -b57600 -D -Uflash:w:main.hex:i
              erst Reset ausloesen, dann warten bis COM5 im Geraetemanager da.
              dann erst programmieren lassen mit avrdude-Zeile ggf. in bat-Datei
              Hexdatei programmieren ggf. mit programmieren.bat oder make program
              Hexdatei auslesen ggf. mit auslesen.bat
              Reset ausloesen und dann programmieren mit programmieren.bat klappt nun
              also erst Reset druecken, dann rasch make program ! 
              das Programm laeuft dann los,  
              es leuchten 2 rote LEDs
              im Geraetemanager gelbe Warnung "USB Serial" 
              es fehlt der USB-Treiber dazu
              win7-usb-serial-driver.inf nutzen aus Ordner driver
              im Geraetemanager steht nun: USB-CO2 (COM8) 
	           Teensy-Treiber (Teensy USB Serial) wuerde auch gehen.
              Verbinden mit hterm.exe. Connect ok.
              keine Ausgaben ueber USB zu sehen.
   19.12.2021 Ausgabe outs(USB,PSTR("\nTest...")); klappt manchmal !
	           Ausgaben per USB kommen wohl extrem rasch nacheinander 
				  durch wenig if-Abfragen in out.c 
              ggf. delay_ms(50) dazwischen noetig?
              manchmal gelingt es nicht mit hterm sich zu verbinden
				  while(1){ 
	             usb_test();   // USB-Test (testet Ausgabe) 
				  }
				  klappt mit diesen Ausgaben mit Pausen dazwischen
				  115200bd ok.
   28.12.2021 Tests mit SparkFun Pro Micro 3.3V 8MHz-Board 
              Auslesen Orig-Software mit auslesen_com12.bat in sicherung.hex:	
				  avrdude -v -patmega32u4 -cavr109 -PCOM12 -b57600 -n -D -Uflash:r:sicherung.hex:i
				  Umstellung von 16 auf 8MHz in Makefile, main.h, delay.h 
				  make klappt 
				  make program (mit COM12 fuer AVRDUDE)
				  klappt erst wenn 2x Reset -> und so Bootloader aktiv
				  Board meldet sich nun nicht mehr im Geraetemanager
				  vermutlich Register falsch programmiert
				  CLKPR kann nicht weiter reduziert werden -> CPU/UART haben halbe Frequenz
				  usart_init(); angepasst an halbe Frequenz
				  usb_init(); anzupassen noch in usb_serial.h
				  es steht da: 
				  #define HW_CONFIG() (UHWCON = 0x01)   USB-Pad-Regler ein
				  #define PLL_CONFIG() (PLLCSR = 0x12) -> 0x02 (00010010 -> 00000010)
              #define USB_CONFIG() (USBCON = ((1<<USBE)|(1<<OTGPADE))) lassen
              #define USB_FREEZE() (USBCON = ((1<<USBE)|(1<<FRZCLK)))  lassen
				  
				  
				  
              RTC steht auf 1.1.00 0:00. Batterie fehlt noch -> eingesetzt 
              RTC laeuft erst an wenn sie gestellt wurde 
              dazu rtc_test(); aufrufen nachdem rtc_set_time_date() korrekt
              gestellt wurde in ds3231.c. Dann rtc_test(); auskommentieren 
              RTC laeuft nun ! 
   28.10.2019 fram_test() -> FRAM-Test 256 byte hinzu 
              ggf. hinzu #include "fm24c64.h" // FRAM-Funktionen
*/


#include <avr/io.h>        // Pins und Interrupt-Tabelle -> siehe auch iom328p.h
#include <avr/pgmspace.h>  // PSTR
#include <avr/interrupt.h> // Interrupts
#include <stdint.h>        // Integer-Datentypen 8-64bit
#include "main.h"          // CPU-Frequenz, sbi, cbi
#include "usart.h"         // USART-Funktionen
#include "delay.h"         // Delay-Funktionen
//#include "spi.h"           // SPI-Funktionen - fuer spi_init() 
//#include "ad7798.h"        // ADC-Funktionen
//#include "max5717.h"       // DAC-Funktionen
//#include "sram23lcv.h"     // SRAM-Funktionen
//#include "fm24c64.h"       // FRAM-Funktionen
//#include "ds3231.h"        // RTC-Funktionen
//#include "lcd44780.h"      // LCD-Funktionen
#include "out.h"           // Zahlenausgabe USART/LCD
//#include "i2c.h"           // i2c_init()
#include "usb_serial.h"    // USB-Funktionen 



#define DEBUG      0       // Debug-Ausgaben einschalten: 1 oder ausschalten: 0

// Global variables
volatile unsigned char load_state;  // Zustandsvariable fuer Steuerung: USART.c 

// Private functions


/*****************************************************************************
*   Function name : main
*   Returns :       None
*   Parameters :    None
*   Purpose :       Contains the main loop of the program
*****************************************************************************/

int main(void)
{
   //unsigned int temp;         // Hilfsvariable
   unsigned char byte;   // Hilfsvariable
   
   signed int r=0;              // fuer USB-Abfrage mit usb_serial.c
   
   // Datensatzzaehler
   unsigned int datensatz=0;        // Datensaetze zaehlen
         
   // set default values for the global variables 
   load_state='A';  // Zustandsvariable, anfangs 'A'
           // 'A'  Anfangszustand 
           // 'S'  Last-Messung starten 
           // 'E'  Last-Messung beenden 
           // 'R'  erfasste Daten aus SRAM auslesen 
           // 'D'  Daten im SRAM loeschen 

   // Initalisierung 
   initialization();  // init CPU-Pins in/out, USART, I2C, USB 
	
	// Interrupts sind nun durch USB-init freigegeben 
	// undefinierte Interrupts abgefangen mit int.c
	// USART-Interrupt aktiv
   
   // optionale Tests/Abgleich der Komponenten 
   
	while(1){ 
	usb_test();   // USB-Test (testet Ausgabe) 
	}
   //fram_test();  // FRAM-Test 256 byte 
   //rtc_test();   // RTC-Test (testet, setzt Datum/Uhr) 
   
   // USB-Kommandos per Terminal des CO2-Sensors  
   //outs_p(USB,PSTR("\nTest:")); // Meldung ausgeben
   
   // Endlosschleife fuer Lastabarbeitung 
   while(1){ 
      
      // USB abfragen - falls Atmega32U4 - sonst sein lassen,
      // denn Eingaben ueber USART kommen per Interrupt 
      r = usb_serial_getchar(); // serielles Zeichen von USB einlesen falls da 
      if (r != -1) {  // nur weiter auswerten wenn aktuelle Eingabe da 
         byte=r;      // nur byte anschauen 
         if (byte=='S' || byte=='E' || byte=='E' || byte=='R' || byte=='D') {
            load_state=byte; // nur zulaessige Zeichen verwerten 
         }
      }
      
      // RTC-Zeitausgabe
      //rtc(USB);             // Datum/Zeit ausgeben (ohne Sekunden) 
      
      // LCD-Ausgabe 2. Zeile: U/I/P falls kein Mess-Modus
      if (load_state!='S'){  // nur ausgeben falls kein Mess-Modus
         // Anzeige weniger nervoes 
         delay_ms(300);   // Anzeigewerte etwas beruhigen 
      }
      
      // Last-Zustand ggf. aendern 
      switch(load_state){   // werte Last-Zustand aus
      
      // default state -> Last ruht - warten auf USART-Kommando S,E,R,D 
      case 'A' : 
         // fange stets mit Datensatz 0 an 
         datensatz=0; 
         
         break;      // fertig 
      
      // Last-Messung starten 
      case 'S' :     
            
         delay_ms(300); // Zeit geben zum Lesen 
            
         // load_state auf E setzen, abbrechen 
         load_state='E';  // Last beenden
            
         break;   // fertig 
                 
         
      // Last-Messung beenden 
      case 'E' : 
        
         delay_ms(500); // Zeit geben zum Lesen 
         
         // load_state auf A setzen
         load_state='A';   // Last startbereit bzw. auslesebereit 
         
         break;      // fertig 
         
      // erfasste Daten aus SRAM auslesen -> USART 
      case 'R' : 
            
         // load_state auf 0 setzen
         load_state='A';  // Last startbereit bzw. auslesebereit
            
         break;           // Schleife abbrechen 
         
      // Daten im SRAM loeschen 
      case 'D' : 
         
         delay_ms(500);    // Meldung 5s halten 
         
         // load_state auf A setzen
         load_state='A';   // Last startbereit bzw. auslesebereit 
         
         break;      // fertig
      // andere Zustaende unzulaessig 
      default: 
         
         delay_ms(500);    // Meldung 5s halten 
         
         // load_state auf A setzen 
         load_state='A';    // Last startbereit bzw. auslesebereit 
      
         break;      // fertig 
      }
   }

   return 0;
}



/*****************************************************************************
*   Function name : initialization
*   Returns :       none
*   Parameters :    none
*   Purpose :       initializate different modules
*****************************************************************************/
void initialization(void)
{
   // OSCCAL_calibration();  // calibrate OSCCAL byte fuer 7.3728 MHz bei Teiler 1 

   // Prescaler einstellen fuer 16 MHz bei 16 MHz-Quarz, 8 MHz bei 8 MHz-Quarz
   // set Clock Prescaler Change Enable
   CLKPR = (1<<CLKPCE);  // Bitmuster von 1 wird um CLKPCE=7 Stellen nach links geschoben 
                         // und dann ins Register CLKPR geschrieben. 1000000 also 
   // Prescaler = 1 -> 16 MHz bei 16 MHz Quarz
   CLKPR = (0<<CLKPS1) | (0<<CLKPS0);  // CPU laeuft mit 16 MHz falls 16MHz-Quarz
                         // CPU laeuft mit 8 MHz falls 8MHz-Quarz	
                         
   //CPU_PRESCALE(0);    // siehe #define in main.h: (CLKPR = 0x80, CLKPR = (n))
                         // erst 1000 0000, dann 0000 0000 fuer ClockDivFactor 1 -> 16 MHz
                         // vgl. Datenblatt ATmega16U4/32U4 2016 S.39 

   // Disable Analog Comparator (power save)
   ACSR = (1<<ACD);      // bit 7 = ACD im Analog Comp Status Register auf 1 setzen schaltet aus
                         // Bitmuster von 1 wird ACD=7 Stellen nach links geschoben. 1000000 also.
                         // spart Strom weil Analog Comp aus.

   // Disable Digital input on analog inputs (power save)
   // DIDR0 = (1<<ADC5D) | (1<<ADC4D) | (1<<ADC3D) | (1<<ADC2D) | (1<<ADC1D) | (1<<ADC0D); //
                         // Digital Input Disable Register 0
                         // schaltet digitale Eingangspuffer der als ADC benutzten Eingnge ab
                         // um Strom zu sparen -> kein digital Input dort

   // Disable Digital input on Ain0 und Ain1 (power save)
   // DIDR1 = (0<<AIN1D) | (0<<AIN0D); // Dig. Inputs werden gebraucht, also nicht Buffer abschalten
                         // Digital Input Disable Register 1

   // DDRB Pins teilweise auf Eingabe
   DDRB = (0<<DDB7) | (0<<DDB6) | (0<<DDB5) | (0<<DDB4) | (0<<DDB3) | (1<<DDB2) | (1<<DDB1) | (1<<DDB0);
            // PB7 = D11                            - in
            // PB6 = D10                            - in
            // PB5 = D9/A8                          - in
            // PB4 = D8        RDY CO2-Sensor       - in
            // PB3 = D14 MISO                       - in
            // PB2 = D16 MOSI                       - out
            // PB1 = D15 SCK                        - out
            // PB0 = D17 SS (gibt SPI frei)         - out

   // PORTB pullup enable fuer Eingnge
   PORTB = (1<<PB7) | (1<<PB6) | (1<<PB5) | (1<<PB4) | (1<<PB3) | (0<<PB2) | (0<<PB1) | (0<<PB0);
            // PortB Daten Register: Enable pullup
            // damit sind bei PortB-Input-Pins die pullups aktiv
            // unbeschaltete Input-Pins nach high gezogen ->
            // verursachen so keine erhhte Stromaufnahme,
            // die auftreten wrde wenn Input-Pins floaten

   // DDRC Pins teilweise auf Eingabe: kein PC0,PC1,PC2,PC3,PC4,PC5
   DDRC = (0<<DDC7) | (0<<DDC6);
            // PC7 = D13   leer                     - in
            // PC6 = D5    leer                     - in
            // PC5 = nicht da                       - in
            // PC4 = nicht da                       - in
            // PC3 = nicht da                       - in
            // PC2 = nicht da                       - in
            // PC1 = nicht da                       - in
            // PC0 = nicht da                       - in

   // PORTC pullup enable fuer Eingnge: kein PC0,PC1,PC2,PC3,PC4,PC5
   PORTC = (1<<PC7) | (1<<PC6);
            // PortC Daten Register: Enable pullup
            // damit sind bei PortC-Input-Pins die pullups aktiv
            // unbeschaltete Input-Pins nach high gezogen ->
            // verursachen so keine erhhte Stromaufnahme,
            // die auftreten wrde wenn Input-Pins floaten

   // DDRD Pins teilweise auf Eingabe
   DDRD = (0<<DDD7) | (0<<DDD6) | (0<<DDD5) | (0<<DDD4) | (1<<DDD3) | (0<<DDD2) | (0<<DDD1) | (0<<DDD0);
            // PD7 = D6/A7                          - in
            // PD6 = D12/A10                        - in
            // PD5 = TX LED                         - in
            // PD4 = D4/A6                          - in
            // PD3 = D1 TXD1  CO2-Sensor            - out
            // PD2 = D0 RXD1  CO2-Sensor            - in
            // PD1 = D2 SDA   FRAM/RTC/TMP75        - in
            // PD0 = D3 SCL   FRAM/RTC/TMP75        - in

   // PORTD pullup enable fuer Eingnge
   PORTD = (1<<PD7) | (1<<PD6) | (1<<PD5) | (1<<PD4) | (0<<PD3) | (1<<PD2) | (1<<PD1) | (1<<PD0);
            // PortD Daten Register: Enable pullup
            // damit sind bei PortD-Input-Pins die pullups aktiv
            // unbeschaltete Input-Pins nach high gezogen ->
            // verursachen so keine erhhte Stromaufnahme,
            // die auftreten wrde wenn Input-Pins floaten

   // DDRE Pins teilweise auf Eingabe: kein PE0,PE1,PE3,PE4,PE5,PE7
   DDRE = (1<<DDE6) | (0<<DDE2);
            // PE7 = nicht da                       - in
            // PE6 = D7       LED1                  - out
            // PE5 = nicht da                       - in
            // PE4 = nicht da                       - in
            // PE3 = nicht da                       - in
            // PE2/HWB = JP1 auf Masse              - in
            // PE1 = nicht da                       - in
            // PE0 = nicht da                       - in

   // PORTE pullup enable fuer Eingnge: kein PE0,PE1,PE3,PE4,PE5,PE7
   PORTE = (1<<PE6) | (1<<PE2);
            // PortE Daten Register: Enable pullup
            // damit sind bei PortE-Input-Pins die pullups aktiv
            // unbeschaltete Input-Pins nach high gezogen ->
            // verursachen so keine erhhte Stromaufnahme,
            // die auftreten wrde wenn Input-Pins floaten

   // DDRF Pins teilweise auf Eingabe: kein PF2,PF3
   DDRF = (1<<DDF7) | (0<<DDF6) | (0<<DDF5) | (0<<DDF4) | (0<<DDF1) | (1<<DDF0);
            // PF7 = A0         Trigger out         - out
            // PF6 = A1                             - in
            // PF5 = A2                             - in
            // PF4 = A3                             - in
            // PF3 = nicht da                       - in
            // PF2 = nicht da                       - in
            // PF1 = A4                             - in
            // PF0 = A5         LED2                - out

   // PORTF pullup enable fuer Eingnge: kein PF2,PF3
   PORTF = (1<<PF7) | (1<<PF6) | (0<<PF5) | (1<<PF4) | (1<<PF1) | (1<<PF0);
            // PortF Daten Register: Enable pullup
            // damit sind bei PortF-Input-Pins die pullups aktiv
            // unbeschaltete Input-Pins nach high gezogen ->
            // verursachen so keine erhhte Stromaufnahme,
            // die auftreten wrde wenn Input-Pins floaten

   // initialisiere UART lt. Table 19-12. Datenblatt ATmega328P S.203
	         // bei 16MHz U2X0=1 9600 -> 207 Fehler 0.2%
            //                  38.4k    51        0.2%
            //                  57.6k    34        0.8%
            //                  115.2k   16        2.1%
            //                  250k      7        0%
            //                  256k      7        2.4%
            //                  0.5M      3        0%
            //                  1M        1        0%
	         // bei 8MHz U2X0=1  9600 -> 103 Fehler 0.2%
            //                  38.4k    25        0.2%
            //                  57.6k    16        2.1%
            //                  115.2k    8        3.5%
            //                  250k      3        0%
            //                  0.5M      1        0%
            //                  1M        0        0%
   //usart_init(207); // 16MHz: ser. Schnittstelle init mit 9600bd, kein FIFO 
	//usart_init(51);  // 16MHz: ser. Schnittstelle init mit 38.4kbd, kein FIFO 
   //usart_init(16);  // 16MHz: ser. Schnittstelle init mit 115.2kbd, kein FIFO 
   //usart_init(7);   // 16MHz: ser. Schnittstelle init mit 256kbd, kein FIFO
	usart_init(103);   // 8MHz: ser. Schnittstelle init mit 9600bd, kein FIFO 

   // USART-Ausgabe um Terminalprogramm zu synchronisieren 
   outc(USART,0xff);  // Zeichen zur Synchronisation/Bestaetigung ueber UART senden 
   outc(USART,'\n');  // neue Zeile ueber UART senden 
   //outc(USB,0xff);  // Zeichen zur Bestaetigung ueber USB senden 
   //outc(USB,'\n');  // neue Zeile ueber USB senden 
   
   //Timer0_init();   // for 10ms Timer
   
   //i2c_init();      // I2C init: Pins SCL, SDA festlegen - ist bei lcd_init() dabei 
   
   usb_init();        // USB init -> siehe usb_serial.h
	while (!usb_configured());  // warte bis konfiguriert
	
   // warte bis Hterm gestartet ist und DTR gesetzt weil empfangsbereit
   while (!(usb_serial_get_control() & USB_SERIAL_DTR)); // warte auf DTR gesetzt
	
	outc(USB,0xff);    // Zeichen zur Synchronisation/Bestaetigung per USB an Hterm senden 
   outc(USB,'\n');    // neue Zeile per USB an Hterm senden
	
	//delay_ms(1000);     // 
}

