// Ausgabe-Treiber   Dr. Weisser 24.11.2016   15.10.2019
// out.h

#ifndef OUT_H_
#define OUT_H_

// devices fuer Ausgabe
#define LCD    0  // falls 1 -> LCD-Ausgabe aktiv, falls 0 -> inaktiv
#define USART  2
#define SRAM   0  // falls 3 -> SRAM-Ausgabe aktiv, falls 0 -> inaktiv
#define USB    4  // falls 4 -> USB-Ausgabe aktiv, falls 0 -> inaktiv

// Funktionsprototypen

void outc(unsigned char device, unsigned char data); 
                 // ein Zeichen ausgeben auf USART/LCD/SRAM/USB
void outs(unsigned char device, const char *str); 
                 // Zeichenfolge aus SRAM ausgeben auf USART/LCD/SRAM/USB
void outs_p(unsigned char device, const char *str); 
                 // Zeichenfolge aus Programmspeicher (Flash) ausgeben auf USART/LCD/SRAM/USB
void out_u16bin(unsigned char device, unsigned int zahl); 
                 // Integer-Zahl binaer als 2 byte ausgeben
void out_u16(unsigned char device, unsigned int zahl, unsigned char vorkomma, unsigned char nachkomma);
                 // Integer-Zahl als ASCII mit n1 Stellen vor Komma und n2 Stellen nach Komma ausgeben
void out_u08(unsigned char device, unsigned char zahl, unsigned char vorkomma, unsigned char nachkomma);
                 // Char-Zahl als ASCII mit n1 Stellen vor Komma und n2 Stellen nach Komma ausgeben
void out_u32(unsigned char device, unsigned long zahl, unsigned char vorkomma, unsigned char nachkomma);
                 // Long-Zahl als ASCII mit n1 Stellen vor Komma und n2 Stellen nach Komma ausgeben
void out_u08_2(unsigned char device, unsigned char zahl);
                 // Char-Zahl als ASCII mit 2 Stellen ausgeben und ggf. Vornull fuer Datum/Zeit

#endif // OUT_H_
